#!/usr/bin/env ruby

=begin
  onDiary; nDiary on the Web (webframe)
  version: for onDiary-0.1 preview

ToDo:
ư˱äɥ/
ưå(&ǥХå)
GUI
  ndiary-config-reader/writer(./script/ndiary.conf)ȤƱ
  comment-config-reader/writer(./www/nboard/nboard.cgi)ȤƱ
  trackback-config-reader/writer(./www/ntb/ntb.cgi)ȤƱ
ԡܥ(dir(./www/)͸dir(../diary/))
ܸfile̾ؤб(äɬפʤΤ?)
Ƽ掠ץν
indexlogoutŬõ?
amazon_shop.rbƳ?
ӥ᡼뤫ι?
filter/inlineimagehref
=end

$: << './webframe/'
require 'webframe'

class OnDiary < WebFrame
  def configure ( config_file = @config_file )
    @version += '+4onDiary-0.1 pre'

    @menu_list = ['index', 'list', 'view', 'edit', 'upload', 'diary', 'config']
    @data_dir  = './log/'
    @base_dirs = ['./log/', './user/', './www/']
    @base_exts = ['.diary', '.dia', '.cfg', '.txt', '.word', '.html', '.rhtml', '.rb', '.jpg', '.png', '.gif']

    @script_dir = './script/'
    @output_dir = './www/'
    @year_dir_option = true
    @month_dir_option = true
    @date_delay = 0
    @config_binary += ['@year_dir_option', '@month_dir_option']
    @config_string += ['@script_dir', '@output_dir']
    @config_number += ['@date_delay']

    super

    open(File::join(@script_dir, 'ndiary-lib.rb')).each{ |line|
      if line =~ %r|^NDIARY_VERSION\s*\=\s*['\"](.*)['\"]\s*$|
        @ndiary_version = $1.strip
        break
      end
    }
    open(File::join(@script_dir, 'ndiary-custom.rb')).each{ |line|
      if line =~ %r|^ONDIARY_VERSION\s*\=\s*['\"](.*)['\"]\s*$|
        @ondiary_version = $1.strip
        break
      end
    }

    @date = (Time.now - @date_delay * 60 * 60).strftime("%Y%m%d")
  end

  def action_data ( mode = @mode ) # ưʬ
    data = {}
    data['charset'] = @charset || 'euc-jp'
    data['title'] = mode
    data['version'] = @version
    data['menu'] = menu

    # ===== ===== onDiary ɲ ===== =====
    data['ndiary_version']  = @ndiary_version
    data['ondiary_version'] = @ondiary_version
    # ===== ===== onDiary ɲ ===== =====

    case mode
    when 'index'
      data['title'] = 'onDiary; nDiary on the Web'
      data['body'] = index

    when 'config'
        data['body'] = config
    when 'config_update'
        data['body'] = config_update

    when 'message'
      data['body'] = message_html({'message_list'=>@message_list})

    when 'login'
#      data['body'] = login_html
      data['body'] = login
    when 'logout'
      @session.delete

    # ===== ===== ץ롣եɽԽ ===== =====
    when 'list'
      data['body'] = list(@file)
    when 'view'
      text = view(@file)
      if text
        data['body'] = text
      else
        data['body'] = "#{@file} : Τ褦ʥե¸ߤޤ"
      end
    when 'edit'
      text = edit(@file)
      if text
        data['body'] = text
      else
        data['body'] = "#{@file} : ΥեԽǤޤ"
      end
    when 'update'
      data['body'] = update(@file, @text)
    when 'delete'
      data['body'] = delete(@file)
    when 'delete_check'
      data['body'] = delete_check(@file)
    when 'upload'
      data['body'] = upload
    when 'upload_check'
      data['body'] = upload_check(@source, @file)
    # ===== ===== ץ뤳ޤǡեɽԽ ===== =====

    # ===== ===== onDiary ɲ ===== =====
    when 'diary'
      data['body'] = diary(@option)
    when 'diary_check'
      data['body'] = diary_check(@option)
    # ===== ===== onDiary ɲ ===== =====

    else
      data['title'] = 'MODE-ERROR'
      data['body'] = message_html({'message'=>"#{mode} : Τ褦Ǥ¸ߤޤ"})
    end

    return data
  end

  def index
    text = <<EOS
<ul>
<li><a href="#{@script_name}?mode=index">index</a> </li>
<li><a href="#{@script_name}?mode=list">list:   ե</a></li>
<li><a href="#{@script_name}?mode=view">view:   (եɽ)</a></li>
<li><a href="#{@script_name}?mode=edit">edit:   </a> </li>
<li><a href="#{@script_name}?mode=upload">upload: ե륢åץ</a></li>
<li><a href="#{@script_name}?mode=diary">diary: </a> nDiary</li>
<li><a href="#{@script_name}?mode=config">config: </a></li>
<li><a href="#{@script_name}?mode=logout">logout: </a> ⡼ɤͭǤС</li>
</ul>
EOS
    return text
  end


  def diary ( option = @option )
    text = <<EOS
<p>
<form method="post">
<input type="hidden" name="mode" value="diary_check" />
ruby diary <input type="text" name="option" value="#{option}" />
<input type="submit" value="update" />
</form>
(񤫤ʤ)ͺǿϢ<br />
2006012006ǯ1<br />
all<br />
</p>
<p>
<a href="#{@output_dir}">ǿ</a>
</p>
EOS
    return text
  end

  def diary_check ( oargv = [], message_file = './message.txt' )
    require 'tempfile'

    argv = oargv.to_a # splitȤerror. ????
    argv.delete('')
    org_dir = Dir::pwd
    org_kcode = $KCODE
    $: << "#{@script_dir}/lib"    # nDiaryȹ饤֥ȹѰ
    Dir::chdir(@script_dir)       # nDiaryΰ֤˰ư
    $KCODE = 'SJIS'               # nDiaryѤʸɤSJISѹ
    fp = Tempfile.open(message_file)
    $stdout = $stderr = fp
    argstr = 'diary'

    # diary(nDiary) Ȥ򥳥ԡ ===== =====

    # ndiary-win32 check
    if defined?(Exerb) and Exerb.runtime? then
      exefile = Exerb.filepath
#      if ARGV[0] == "-d" then
      if argv[0] == "-d" then
        $DEBUG = true
        argv.shift
      end
    else
#      exefile = $0
#      exefile = File.readlink($0) if FileTest.symlink?($0)
      exefile = argstr
      exefile = File.readlink(argstr) if FileTest.symlink?(argstr)
    end
    dir = File::dirname(exefile)
    Dir::chdir(dir)
    $: << dir

    # Execute Script
    require 'ndiary-lib.rb'
    require 'ndiary-custom.rb'    # ɲ
#    main
    begin
      main(argv)
    rescue Exception
      fp.puts $!
    end

    # diary(nDiary) Ȥ򥳥ԡޤ ===== =====

    $stdout, $stderr = STDOUT, STDERR
    fp.close
    fp.open
    message = h(convert(fp.read))
    fp.close(true)
    $KCODE = org_kcode            # ʸɤ
    Dir::chdir(org_dir)

    text = <<EOS
<tt><pre class="ndiary">#{message}</pre></tt>
<p>
<a href="#{@output_dir}">ǿ</a>
</p>
EOS
    return text
  end

  def list ( dir = @data_dir ) # ե
    dir = path_check(dir)
    baselist = []
    baselist << %Q|<a href="#{@script_name}?mode=list;file=#{@data_dir}">dir()</a>| if dir != @data_dir
    baselist << %Q|<a href="#{@script_name}?mode=list;file=#{File::join(@output_dir, '/enikki/')}">dir()</a>| if dir != File.join(@output_dir, '/enikki/')
    linklist = []
    @base_dirs.each{ |file| linklist << %Q|<a href="#{@script_name}?mode=list;file=#{file}">#{file}</a>| }
    filelist = [['filename', 'timestamp', 'size', 'edit']]
    Dir::open(dir).sort.each{ |file|
      file = File::join(dir, file)
      if file =~ /^\.\//
        file = $'
      end
      file.gsub!(/\/\.\//, '/')
      if File::file?(file)
        next unless ext_check(file)
        date = File::mtime(file)
        size = File::size(file)
      end
      link = %Q|<a href="#{@script_name}?mode=view;file=#{file}">#{file}</a>|
      link = %Q|<a href="#{@script_name}?mode=list;file=#{file}">#{file}</a>| if File::directory?(file)
      if File::file?(file)
        elink = %Q|<a href="#{@script_name}?mode=edit;file=#{file}">(edit)</a>|
        dlink = %Q|<a href="#{@script_name}?mode=delete;file=#{file}">(del)</a>|
      end
      filelist << [link, date, size, elink, dlink]
    }
#    ext = dir == File::join(@output_dir, '/enikki/') ? '.png' : '.diary' 
#    if ext == '.diary'
#      if @year_dir_option
#        dir = File::join(@data_dir, @date[0..3])
#        dir = File::join(dir, @date[4..5]) if @month_dir_option
#      end
#    end
#    newfile = File::join(dir, "#{@date}#{ext}")
    newfile = dir
    text = <<EOS
<div class="list">
#{baselist.join(' | ')}
</div>
<div class="list">
#{linklist.join(' | ')}
</div>
<form method="post">
<input type="hidden" name="mode" value="edit" />
<input class="text" type="text" name="file" value="#{newfile}" />
<input type="submit" value="(newfile)" />
<a href="#{@script_name}?mode=upload;file=#{newfile}">(upload)</a>
</form>
#{table(filelist, 'list', true)}
EOS
    return text
  end

  def edit ( file = @file ) # եԽ
    if @cgi['file'].empty?
      dir = @data_dir
      dir = File::join(dir, @date[0..3]) if @year_dir_option
      dir = File::join(dir, @date[4..5]) if @month_dir_option
      file = File::join(dir, "#{@date}.diary")
    end

    file = path_check(file)
    return false unless ext_check(file)
    if File::exist?(file)
      return false unless File::file?(file)
      return false unless File::writable?(file)
      text = convert(open(file).read)
      text = h(ndiary_convert(text, :read))
    end

    option_str = ''
      file1 = file2 = file3 = ''
    if File::basename(file) =~ /(\d{4})(\d{2})(\d{2})\./
      year, month, day = $1.strip, $2.strip, $3.strip
      option_str = <<EOS
<input type="radio" name="option" value="now" /> ¸ƺǿ򹹿<br />
<input type="radio" name="option" value="#{year}#{month}" /> ¸#{year}ǯ#{month}򹹿<br />
EOS
      file1 = File::join(@output_dir, '/enikki/', "#{year}#{month}#{day}.jpg")
      file2 = File::join(@output_dir, '/enikki/', "#{year}#{month}#{day}_2.jpg")
      file3 = File::join(@output_dir, '/enikki/', "#{year}#{month}#{day}_3.jpg")
    end

    text = <<EOS
<div class="edit">#{file}</div>
<form method="post" enctype="multipart/form-data">
<input type="hidden" name="enctype_multipart" value="on" />
<input type="hidden" name="mode" value="update" />
<input type="hidden" name="file" value="#{file}" />
<textarea name="text">#{text}</textarea><br />

1 : <input type="file" name="source1" />
to : <input class="text" type="text" name="file1" value="#{file1}" /><br />
2 : <input type="file" name="source2" />
to : <input class="text" type="text" name="file2" value="#{file2}" /><br />
3 : <input type="file" name="source3" />
to : <input class="text" type="text" name="file3" value="#{file3}" /><br />

#{option_str}
<input type="submit" value="edit" />
</form>
EOS
    return text
  end

  def update ( file = @file, text = @text ) # ե빹
    file = path_check(file)
    return false unless ext_check(file)
    if File::exist?(file)
      return false unless File::file?(file)
      return false unless File::writable?(file)
    else
      dir = File::dirname(file)
      mkdir = []
      while !File::exist?(dir)
        mkdir << dir
        dir = File::dirname(dir)
      end
      mkdir.reverse.each{ |dir| Dir::mkdir(dir) }
    end
    text = ndiary_convert(text, :write)
    open(file, 'w'){ |fp| fp.write(convert(text, @file_kcode)) }

    source1 = @cgi['source1'] if @cgi.has_key?('source1')
    source2 = @cgi['source2'] if @cgi.has_key?('source2')
    source3 = @cgi['source3'] if @cgi.has_key?('source3')
    file1 = @cgi['file1'] if @cgi.has_key?('file1')
    file2 = @cgi['file2'] if @cgi.has_key?('file2')
    file3 = @cgi['file3'] if @cgi.has_key?('file3')
    if @cgi.has_key?('enctype_multipart')
      source1 = @cgi['source1'].read if @cgi.has_key?('source1')
      source2 = @cgi['source2'].read if @cgi.has_key?('source2')
      source3 = @cgi['source3'].read if @cgi.has_key?('source3')
      file1 = @cgi['file1'].read if @cgi.has_key?('file1')
      file2 = @cgi['file2'].read if @cgi.has_key?('file2')
      file3 = @cgi['file3'].read if @cgi.has_key?('file3')
    end
    unless source1.to_s.empty?
      unless file1.to_s.empty?
        upload_file(source1, file1)
      end
    end
    unless source2.to_s.empty?
      unless file2.to_s.empty?
        upload_file(source2, file2)
      end
    end
    unless source3.to_s.empty?
      unless file3.to_s.empty?
        upload_file(source3, file3)
      end
    end

    if @option == 'now'
      return diary_check('') # ???
    elsif !@option.to_s.empty?
      return diary_check(@option)
    end

    return view(file)
  end

  def upload ( source = '', file = @file )
    file = File::join(@output_dir, '/enikki/', "#{@date}.jpg") if @cgi['file'].empty?
    text = <<EOS
<form method="post" enctype="multipart/form-data">
<input type="hidden" name="enctype_multipart" value="on" />
<input type="hidden" name="mode" value="upload_check" />
from:
<input type="file" name="source" /><br />
to:
<input class="text" type="text" name="file" value="#{file}" /><br />
mode:
<input type="radio" name="upmode" value="ascii" />ascii
<input type="radio" name="upmode" value="binary" />binary<br />
<input type="submit" value="upload" />
</form>
EOS
    return text
  end


  def ndiary_convert ( text = '', mode = :read ) # Ѷ4ĢTAB
    if mode == :read
      text.gsub!(/\t/, '')
    else # mode == :write
      case @kcode
      when 'euc';   text.gsub!(//e, "\t")
      when 'sjis';  text.gsub!(//s, "\t")
      when 'utf8';  text.gsub!(//u, "\t")
      when 'jis';   text.gsub!(//,  "\t")
      end
    end
    return text
  end
end

frame = OnDiary.new
frame.configure('./webframe/ondiary.cfg')
frame.action
