#!/usr/bin/env ruby

=begin
  WebFrame
    CGI-interfaceοȤޤ
    RailsFramework?ˤϿޤŤǤǤ̺Ǿ¤ǡ
    ȡǤϤޤˤʤΤǡ
    եɽԽǤ褦ˤƤޤ
     ruby-1.8 ʾ

   ver.1.1  2006/1/7 by ippo
=end

require 'cgi'
require 'cgi/session'
require 'erb'
require 'kconv'

class WebFrame
  VERSION = '1.1'

  include ERB::Util

#  extend ERB::DefMethod
#  def_erb_method('frame_html(data)',   './frame.rhtml')   # ե̾
#  def_erb_method('message_html(data)', './message.rhtml') # Ǥʤ餳

  # =====  =====
  def initialize ( debug = false, config_file = './webframe.cfg' )
    @debug, @config_file = debug, config_file
    @cgi = CGI.new
    @session = CGI::Session.new(@cgi)
    @cgi, @session = nil, [] if @debug == 'console'
    @version = VERSION
    @kcode = 'euc'             # ʸ
    @rcode = "\n"              # +ɽԥ
    @file_kcode = 'euc'        # ե¸ʸ
    @file_rcode = "\n"         # ե¸ԥ

    @login_mode = false #true # false
    @password = 'password'

    @type = 'text/html'
    @charset = 'euc-jp'        # ɽʸ(html)

    @script_name  = ENV['SCRIPT_NAME'].to_s
    @http_referer = ENV['HTTP_REFERER'].to_s

    @frame_rhtml   = './frame.rhtml'
    @message_rhtml = './message.rhtml'
#    @login_rhtml   = './login.rhtml' # 

    @menu_list = ['index', 'list', 'view', 'edit', 'upload', 'config']
    # 'config_update' ¾Խܤΰٽ

    @config_binary = ['@login_mode']
    @config_string = ['@password', '@file_kcode', '@file_rcode', '@charset', '@frame_rhtml', '@message_rhtml', '@data_dir']
    @config_number = ['@max_file_size']
    # config ǽǤѥ᡼λ

    if @cgi.class == CGI
      @mode = @cgi['mode'] if @cgi.has_key?('mode')
      @session['password'] = @cgi['password'] if @cgi.has_key?('password')
      # ɬפ˱ݻϤΤɲäǽ
      @file   = @cgi['file']   if @cgi.has_key?('file')
      @text   = @cgi['text']   if @cgi.has_key?('text')
      @source = @cgi['source'] if @cgi.has_key?('source')
      @upmode = @cgi['upmode'] if @cgi.has_key?('upmode')
      @option = @cgi['option'] if @cgi.has_key?('option')
      @options = {}
      @cgi.keys.each{ |key| @options[key] = @cgi[key] }
      if @cgi.has_key?('enctype_multipart') # Ƥ StringIO 
        @mode = @cgi['mode'].read     if @cgi.has_key?('mode')
        @file = @cgi['file'].read     if @cgi.has_key?('file')
        @text   = @cgi['text'].read   if @cgi.has_key?('text')
        @source = @cgi['source'].read if @cgi.has_key?('source')
        @upmode = @cgi['upmode'].read if @cgi.has_key?('upmode')
        @option = @cgi['option'].read if @cgi.has_key?('option')
      end
    end

    # ===== ===== ץ롣եɽԽ ===== =====
    @data_dir  = '.'   # եΥǥեȰ
    @base_dirs = ['.'] # ե°֡겼ʤ
    @base_exts = []    # ե³ĥҡ̵
    @binary_exts = ['.png', '.jpg', '.jpeg', '.gif', '.bmp', '.tiff']
    @max_file_size = 16384
    # ===== ===== ץ뤳ޤǡեɽԽ ===== =====
  end

  def configure ( config_file = @config_file, force = false ) # 2initializeɬ
    @config_file = config_file
    if File::exist?(@config_file.to_s)
      eval(convert(open(@config_file).read))
    else
      warning_message("config: #{@config_file} ޤ") unless force
    end
    
    # config_fileǤȿǤξǽƼ
    @mode = @mode || 'index'
    @header = {'type'=>@type, 'charset'=>@charset}
    if @login_mode
      if login_check
        @menu_list << 'logout'
      else
        @menu_list << 'login'
      end
    end
    @file = @file || @data_dir
  end


  # ===== ᥤ =====
  def action ( mode = @mode )
    if @debug == :action
      mode = 'login' unless login_check
      data = action_data(mode)
    else
      begin
        mode = 'login' unless login_check
        data = action_data(mode)
      rescue Exception
        data = {'title'=>"#{$!.class} : #{$!.message}", 'body'=>message_html({'message_list'=>$@})}
      end
    end
    output(frame_html(data))
  end

  def action_data ( mode = @mode ) # ưʬ
    data = {}
    data['charset'] = @charset || 'euc-jp'
    data['title'] = mode
    data['version'] = @version
    data['menu'] = menu

    case mode
    when 'index'
      data['body'] = 'indexǤ'

    when 'config'
        data['body'] = config
    when 'config_update'
        data['body'] = config_update

    when 'message'
      data['body'] = message_html({'message_list'=>@message_list})

    when 'login'
#      data['body'] = login_html
      data['body'] = login
    when 'logout'
      @session.delete

    # ===== ===== ץ롣եɽԽ ===== =====
    when 'list'
      data['body'] = list(@file)
    when 'view'
      text = view(@file)
      if text
        data['body'] = text
      else
        data['body'] = "#{@file} : Τ褦ʥե¸ߤޤ"
      end
    when 'edit'
      text = edit(@file)
      if text
        data['body'] = text
      else
        data['body'] = "#{@file} : ΥեԽǤޤ"
      end
    when 'update'
      data['body'] = update(@file, @text)
    when 'delete'
      data['body'] = delete(@file)
    when 'delete_check'
      data['body'] = delete_check(@file)
    when 'upload'
      data['body'] = upload
    when 'upload_check'
      data['body'] = upload_check(@source, @file, @upmode)
    # ===== ===== ץ뤳ޤǡեɽԽ ===== =====

    else
      data['title'] = 'MODE-ERROR'
      data['body'] = message_html({'message'=>"#{mode} : Τ褦Ǥ¸ߤޤ"})
    end

    return data
  end


  # ===== ƥ =====
  def login # erb(rhtml)Ѥʤ硣ȤξѰա
    options_str = ''
    @options.each{ |key, val|
      options_str << %Q|<input type="hidden" name="#{key}" value="#{val}" />\n|
    }
    data = {'options'=>options_str}
    text = <<EOS
<h2>󤷤Ʋ</h2>
<p>
<form method="post">
#{data['options']}
PASSWORD : <input type="password" name="password" />
<input type="submit" value="LOGIN" />
</form>
</p>
EOS
    return text
  end

  def config ( file = @config_file ) # եԽŬ
    binary = @config_binary
    string = @config_string
    number = @config_number
    info, comments = {}, {}
    text = convert(open(file).read)
    text.each{ |line|
      (binary + string+ number).each{ |key|
        if line =~ /^#{key}\s*\=\s*(.*)$/
          info[key] = $1.strip
          info[key] = eval(info[key]) if binary.include?(key)
          info[key] = info[key].to_i  if number.include?(key)
          if string.include?(key)
            if info[key] =~ /^'(.*)'$/
              info[key] = $1.strip
            elsif info[key] =~ /^\"(.*)\"$/
              info[key] = $1.strip
            end
          end
        elsif line =~ /^\##{key}\#\s*(.*)$/
          comments[key] = $1.strip
        end
      }
    }
    str = %Q|<div class="config"><form method="post">\n|
    str << %Q|<input type="hidden" name="mode" value="config_update" />\n|
    list = []
    binary.each{ |key|
      check = info[key] ? ' checked' : ''
      list << [%Q|#{key} = |, %Q|<input type="checkbox" name="#{key}"#{check} /> (true/false)|, comments[key]]
#      str << %Q|#{key} = <input type="checkbox" name="#{key}"#{check} /> (true/false)<br />\n|
    }
    (string + number).each{ |key|
      list << [%Q|#{key} = |, %Q|<input class="text" type="text" name="#{key}" value="#{h(info[key].to_s)}" />|, comments[key]]
#      str << %Q|#{key} = <input type="text" name="#{key}" value="#{h(info[key].to_s)}" /><br />\n|
    }
    str << table(list, 'list')
    str << %Q|<input type="submit" value="edit" />\n|
    str << %Q|</form></div>\n|
    return str
  end

  def config_update ( file = @config_file ) # ե빹Ŭ
    binary = @config_binary
    string = @config_string
    number = @config_number
    info = {}
    if @cgi.class == CGI
      (binary + string + number).each{ |key|
        info[key] = convert(@cgi[key]).strip if @cgi.has_key?(key)
      }
    end
    text = convert(open(file).read)
    binary.each{ |key|
      unless info[key].nil?
        info[key] = info[key] == 'on' ? true : false
        text.sub!(/^#{key}\s*\=\s*.*$/, %Q|#{key} = #{info[key].to_s}|)
      end
    }
    string.each{ |key|
      text.sub!(/^#{key}\s*\=\s*.*$/, %Q|#{key} = '#{info[key]}'|) unless info[key].nil?
    }
    open(file, 'w'){ |fp| fp.write(convert(text, @file_kcode, @file_rcode)) }
    return config
  end


  # =====  =====
  def login_check
    return true unless @login_mode
    return true if @session['password'] == @password
    return false
  end

  def menu ( menu_list = @menu_list, mode = @mode, options = {} )
    list = []
    menu_list.each{ |name|
      option = []
      option << "mode=#{name}"
      options.each{ |key, val| option << "#{key}=#{val}" }
      option = '?' + option.join(';') unless option.empty?
      unless mode == name
        list << %Q|<a href="#{@script_name}#{option}">#{name}</a>|
      else
        list << name
      end
    }
#    return list
    return %Q|<div class="menu">[ #{list.join(' | ')} ]</div>|
  end


  def frame_html ( data = {} )
    return ERB.new(convert(open(@frame_rhtml).read)).result(binding)
  end

  def message_html ( data = {} )
    return ERB.new(convert(open(@message_rhtml).read)).result(binding)
  end

#  def login_html ( data = {} ) # erb(rhtml)Ѥ硣ȤξѰա
#    options_str = ''
#    @options.each{ |key, val|
#      options_str << %Q|<input type="hidden" name="#{key}" value="#{val}" />\n|
#    }
#    data.update({'options'=>options_str})
#    return ERB.new(convert(open(@login_rhtml).read)).result(binding)
#  end


  def warning_message ( str )
    message("WAR; #{str}")
  end

  def error_message ( str )
    message("ERR; #{str}")
  end

  def message ( str )
    if @cgi.class == CGI
      @mode = 'message'
      @message_list = [] if @message_list.nil?
      @message_list << str
    else
      output(str, $stderr)
    end
  end


  def output ( str, io = $stdout )
    if @cgi.class == CGI
      @cgi.out(@header){ convert(str, @charset) }
    else
      io.puts convert(str, @charset)
    end
  end


  def convert ( str = '', kcode = @kcode, rcode = @rcode, chomp_option = false )
    str =
    case kcode.downcase
    when 'euc',  'euc-jp';      str.toeuc
    when 'sjis', 'shift_jis';   str.tosjis
    when 'utf8', 'utf-8';       str.toutf8
    when 'jis',  'iso-2022-jp'; str.tojis
    else;                       str
    end

    rcode =
    case rcode.downcase
    when 'unix'; "\n"
    when 'dos';  "\r\n"
    when 'mac';  "\r"
    else;        rcode
    end
    str = str.map{ |line| line.chomp + rcode }.join
    str.chomp! if chomp_option

    return str
  end


# ===== ===== ץ롣եɽԽǽ ===== =====

  def list ( dir = @data_dir ) # ե
    dir = path_check(dir)
    linklist = []
    @base_dirs.each{ |file| linklist << %Q|<a href="#{@script_name}?mode=list;file=#{file}">#{file}</a>| }
    filelist = [['filename', 'timestamp', 'size', 'edit']]
    Dir::open(dir).sort.each{ |file|
      file = File::join(dir, file)
      if file =~ /^\.\//
        file = $'
      end
      file.gsub!(/\/\.\//, '/')
      if File::file?(file)
        next unless ext_check(file)
        date = File::mtime(file)
        size = File::size(file)
      end
      link = %Q|<a href="#{@script_name}?mode=view;file=#{file}">#{file}</a>|
      link = %Q|<a href="#{@script_name}?mode=list;file=#{file}">#{file}</a>| if File::directory?(file)
      if File::file?(file)
        elink = %Q|<a href="#{@script_name}?mode=edit;file=#{file}">(edit)</a>|
        dlink = %Q|<a href="#{@script_name}?mode=delete;file=#{file}">(del)</a>|
      end
      filelist << [link, date, size, elink, dlink]
    }
    text = <<EOS
<div class="list">
#{linklist.join(' | ')}
</div>
<form method="post">
<input type="hidden" name="mode" value="edit" />
<input class="text" type="text" name="file" value="#{dir}" />
<input type="submit" value="(newfile)" />
<a href="#{@script_name}?mode=upload;file=#{dir}">(upload)</a>
</form>
#{table(filelist, 'list', true)}
EOS
    return text
  end

  def view ( file = @file ) # եɽ
    file = path_check(file)
    return false unless ext_check(file)
    return false unless File::file?(file)
    if @binary_exts.include?(File::extname(file)) # binary(image)Ƚ
      text = %Q|<div class="edit"> #{file} <a href="#{@script_name}?mode=delete;file=#{file}">(del)</a></div><div class="view"><img src="#{file}" alt="#{file}"></div>|
    else
      text = %Q|<div class="edit"> #{file} <a href="#{@script_name}?mode=edit;file=#{file}">(edit)</a> <a href="#{@script_name}?mode=delete;file=#{file}">(del)</a></div><div class="view"><pre>#{h(convert(open(file).read))}</pre></div>|
    end
    return text
  end

  def edit ( file = @file ) # եԽ
    file = path_check(file)
    return false unless ext_check(file)
    if File::exist?(file)
      return false unless File::file?(file)
      return false unless File::writable?(file)
      text = h(convert(open(file).read))
    end
    text = <<EOS
<div class="edit">#{file}</div>
<form method="post">
<input type="hidden" name="mode" value="update" />
<input type="hidden" name="file" value="#{file}" />
<textarea name="text">#{text}</textarea><br />
<input type="submit" value="edit" />
</form>
EOS
    return text
  end

  def update ( file = @file, text = @text ) # ե빹
    file = path_check(file)
    return false unless ext_check(file)
    if File::exist?(file)
      return false unless File::file?(file)
      return false unless File::writable?(file)
    end

    open(file, 'w'){ |fp| fp.write(convert(text, @file_kcode)) }
    return view(file)
  end

  def delete ( file = @file ) # ե(ǧ)
    file = path_check(file)
    return false unless ext_check(file)
    if File::exist?(file)
      return false unless File::file?(file)
      return false unless File::writable?(file)
    end
    text = %Q|#{file} : ˺ޤ<a href="#{@script_name}?mode=delete_check;file=#{file}">(yes)</a>|
    return text
  end

  def delete_check ( file = @file ) # ե
    file = path_check(file)
    return false unless ext_check(file)
    if File::exist?(file)
      return false unless File::file?(file)
      return false unless File::writable?(file)
      File::delete(file)
    end
    text = %Q|#{file} : եޤ|
    return text
  end

  def upload ( source = '', file = @file )
    text = <<EOS
<form method="post" enctype="multipart/form-data">
<input type="hidden" name="enctype_multipart" value="on" />
<input type="hidden" name="mode" value="upload_check" />
from:
<input type="file" name="source" /><br />
to:
<input class="text" type="text" name="file" value="#{file}" /><br />
mode:
<input type="radio" name="upmode" value="ascii" />ascii
<input type="radio" name="upmode" value="binary" />binary<br />
<input type="submit" value="upload" />
</form>
EOS
    return text
  end

  def upload_check ( source = @source, file = @file, upmode = @upmode )
    newfile = path_check(file)
    if file != path_check(file)
      return %Q|#{file}ؤϥåץɤǤޤ|
    end
    unless ext_check(file)
      return %Q|#{file}γĥҤΥեϥåץɤǤޤ|
    end
    if source.size > 0
      upload_file(source, file, upmode)
      text = %Q|#{file}إåץɤޤ|
    else
      text = %Q|ե뤬¸ߤʤȤޤ|
    end
    return text
  end

  # =====  =====
  def path_check ( file, base_dirs = @base_dirs ) # ¡ְʲ
    flag = false
    path = File::expand_path(file)
    base_dirs.each{ |base_dir|
      base_path = File::expand_path(base_dir)
      flag = true if path =~ %r|^#{base_path}|
    }
    if path =~ %r|^#{File::expand_path(@data_dir)}|
      file =  File::join(@data_dir, $')
    end

    file = base_dirs.first unless flag
#    return flag # Ƚ
    return file # Ǽư
  end

  def ext_check ( file, base_exts = @base_exts ) # ¡ĥҤΤ
    flag = false
    ext = File::extname(file)
    if base_exts.empty?
      flag = true
    else
      flag = true if base_exts.include?(ext)
    end
    return flag
  end

  def table ( list = [[]], class_name = nil, title = false, split_size = 50, options = [:stripe] ) # ơ֥
    count, stripe_count = 0, 0
    option = %Q| class="#{class_name}"| if class_name
    header = "<table#{option}>\n"
    footer = "</table>\n"

    str = ''
    str << header
    if title
      line_str = ''
      list.shift.to_a.each{ |val|
        line_str << %Q|<th>#{val}</th>|
      }
      str << %Q|<tr>#{line_str}</tr>\n|
    end
    list.each{ |line|
      line_str = ''
      line.to_a.each{ |val|
        line_str << %Q|<td>#{val}</td>|
      }
      option = ''
      if options.include?(:stripe)
        option = stripe_count == 1 ? %Q| class="color1"| : %Q| class="color0"|
        stripe_count = 1 - stripe_count
      end
      str << %Q|<tr#{option}>#{line_str}</tr>\n|
      count += 1
      if count >= split_size
        str << footer
        str << header
        count = 0
      end
    }
    str << footer
  end

  def upload_file ( from_data, to_file, mode = nil )
    if mode.nil?
      mode = @binary_exts.include?(File::extname(to_file)) ? :binary : :ascii
    else
      mode = mode.strip == 'binary' ? :binary : :ascii
    end
    file = from_data
    raise %Q|#{@max_file_size}byteۤեϥåץɤǤޤ| if file.size > @max_file_size
    option = 'wb' # :binary(image)
    if mode == :ascii
      option = 'w'
      file = convert(file)
    end
    open(to_file, option){ |fp| fp.write(file) }
  end

# ===== ===== ץ뤳ޤǡեɽԽ ===== =====

end

if $0 == __FILE__
  frame = WebFrame.new
  frame.configure
#  frame.configure(nil, true) #config-fileʤǶ
  frame.action
end
