# [ruby-list:28267] Qlɍ쐬܂B

class Lock
  class LockError < StandardError; end

  def initialize(basefile = 'lockfile')
    @locking = false
    @basefile = basefile
    @lockfile = "#{@basefile}_._#{Process::pid}_._#{Time.now.to_i}"
  end

  def lock(try = 10, timeout = 600)
    1.upto(try) do |time|
      begin
        File::rename(@basefile, @lockfile)
        @locking = true
        break
      rescue
        begin
          lockfiles = Dir.glob("#{@basefile}_._*")
          if lockfiles.size.zero? then
            begin
              Dir::mkdir(@basefile)
              retry
            rescue
            end
          end
          lockfiles.each{ |oldlock|
            if /^#{@basefile}_\._\d+_\._(\d+)/ =~ oldlock and
                Time.now.to_i - $1.to_i > timeout then
              File::rename(oldlock, @lockfile)
              @locking = true
              break
            end
          }
        rescue
        end
      end
      sleep 1
    end
    if @locking then
      return true
    else
      return false
    end
  end

  def unlock
    File::rename(@lockfile, @basefile) if @locking
  end

  def Lock::lock(basefile = 'lockfile', try = 10, timeout = 600)
    l = Lock::new(basefile)
    unless l.lock(try, timeout) then
      raise Lock::LockError, "LockError: #{basefile} #{$!}"
    end
    yield
    l.unlock
  end
end
