# 2006/1/10 ꕔC

require 'cgi'
require 'net/smtp'
require 'ftools'
require 'filelock'

require 'kconv'
=begin
class String
  require 'nkf'
  
  def kconv(code)
    case code
    when 1
      self.tojis
    when 2
      self.toeuc
    when 3
      self.tosjis
    end
  end

  def tosjis
    begin
      require 'string_u'
      self.tosjis_u
    rescue NameError, LoadError
      NKF::nkf("-smx0", self)
    end
  end

  def toeuc
    NKF::nkf('-em0', self)
  end

  def tojis
    NKF::nkf('-jm0', self)
  end

end
=end

module NTrackBack

  class Main

    def initialize
      @now = Time::now
      @monthlyFilename = MONTHLY_FILENAME
      @monthPartNames = [''] * 32
      @monthPartNames[1,0] = MONTH_PART_NAMES
      @monthPartNames = @monthPartNames[0..31]
      @cgi = CGI::new
    end

    def start

      lock = Lock::new(LOG_DIRECTORY + '/ntblock')
      unless lock.lock(1, 180) then
        error_response('Server Busy')
        exit
      end

    
      if %r"^/\d\d\d\d\d\d\d\d$" =~ @cgi.path_info then
        if @cgi.query_string == "__mode=view" then
          view
        elsif @cgi.query_string == "__mode=rss" then
          view_list
        elsif @cgi['__mode'][0] == 'admin' then
          admin
        elsif @cgi.request_method == "POST" then
          catch_trackback
        else
          error_response('Invalid Request Method')
        end
      else
        error_response('Invalid Trackback Ping URL')
      end

      lock.unlock

    end

    def catch_trackback
      article = Article::new
      article.title = CGI::escapeHTML(@cgi.params['title'].to_s.strip.tosjis)
      article.url = CGI::escapeHTML(@cgi.params['url'].to_s.strip.tosjis)
      article.blog_name = CGI::escapeHTML(@cgi.params['blog_name'].to_s.strip.tosjis)
      article.excerpt = CGI::escapeHTML(@cgi.params['excerpt'].to_s.strip.tosjis)

      list = Articles::new(@cgi.path_info[1..-1])
      if %r"http://" !~ article.url then
        error_response('Invalid url, or url is empty')
        return
      else
        list.each{ |art|
          if art.url == article.url then
            error_response('This url is already tracknbacked.')
            return
          end
        }
      end
      
      if article.excerpt.size > 254 then
        article.excerpt = article.excerpt[0..252]
        article.excerpt.chop! unless article.excerpt.sub!(/.$/,'')
        article.excerpt << '...'
      end

      article.ip = @cgi.remote_addr
      article.host = @cgi.remote_host
      
      list.add(article)
      list.save

      put_count(list)
      success_response
      update_diaryfile_lastmodified
      sendmail(article)
    end

    def put_count(list = nil)
      list = Articles::new(@cgi.path_info[1..-1]) if list.nil?
      count = 0
      list.each{ |art|
        count += 1 if art.delete_flag != true
      }
      open(@cgi.path_info[1..-1] + '.txt', 'w'){ |f|
        f.print "(#{count.to_s})"
      }
      File::chmod(0666, @cgi.path_info[1..-1] + '.txt')

    end

    
    def view
      list = Articles::new(@cgi.path_info[1..-1])
      items = ''
      list.each{ |article|
        unless article.delete_flag then
          if article.title.empty? then
            title = article.url
          else
            title = article.title
          end
          items << <<ITEM_END
<p>
<a id="tb#{article.tb_no}" href="#{article.url}"><span class="trackbacktitle">#{title}</span></a><br />
  <strong>BlogName:</strong> #{article.blog_name}<br />
  <strong>Date:</strong> #{article.date.strftime('%Y/%m/%d %H:%M:%S')}<br />
  <strong>Excerpt:</strong> #{article.excerpt}<br />
</p>
ITEM_END
        end
      }

      css = %Q!\n  <link rel="stylesheet" type="text/css" href="#{CSS}" />! unless CSS.to_s.empty?
  
      
      print <<HTML_END
Content-Type: text/html; charset=Shift_JIS

<?xml version="1.0" encoding="Shift_JIS"?>
<!DOCTYPE html
   PUBLIC "-//W3C//DTD XHTML 1.1//EN"
   "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS" />
  <meta http-equiv="Content-Style-Type" content="text/css" />#{css}
  <title>#{TITLE} (#{@cgi.path_info[1..-1]})</title>
</head>

<body>
<h1>#{TITLE} (#{@cgi.path_info[1..-1]})</h1>

<p><a href="#{LINK_BASE + date2monthlyfilelink(@cgi.path_info[1..-1], true)}">#{@cgi.path_info[1..4]+'-'+@cgi.path_info[5..6]+'-'+@cgi.path_info[7..8]}̓L</a> TrackBack 邽߂ URL: http://#{@cgi.server_name + @cgi.script_name + @cgi.path_info}</p>


<p>̃tH[ TrackBack o܂</p>

<div class="trackbackform">
<form name="tbform" action="http://#{@cgi.server_name + @cgi.script_name + @cgi.path_info}"
method="POST" enctype="application/x-www-form-urlencoded">
<table>
<tr><td>^Cg:</td><td><input type="text" name="title" value="" size="50"></td></tr>
<tr><td>URL(K{):</td><td><input type="text" name="url" value="" size="50"></td></tr>
<tr><td>e:</td><td><input type="text" name="excerpt" value="" size="50"></td></tr>
<tr><td>BlogName:</td><td><input type="text" name="blog_name" value="" size="50"></td></tr>
<tr><td></td><td><input type="submit" value="TrackBack" class="submit"></td></tr>
</table>
</form>
</div>

<hr>

<div class="trackback">
#{items}
</div>

<hr>
<p><a href="?__mode=admin">Ǘ</a></p>
</body>
</html>
HTML_END

    end

    def admin
      list = Articles::new(@cgi.path_info[1..-1])

      if @cgi['password'][0] != PASSWORD then
        password_form
        return
      end
      
      if @cgi.params.key?('check') then
        @cgi['check'].each{ |no|
          list[no.to_i - 1].update = true
          if list[no.to_i - 1].delete_flag then
            list[no.to_i - 1].delete_flag = false
          else
            list[no.to_i - 1].delete_flag = true
          end
        }
        list.save
        put_count(list)
        update_diaryfile_lastmodified
      end

      items = ''
      list.each{ |article|
        if article.title.empty? then
          title = article.url
        else
          title = article.title
        end
          items << <<ITEM_END
<p>
<input type="checkbox" name="check" value="#{article.tb_no}"> #{article.delete_flag ? '<del>' : '폜'}<br />
#{article.tb_no}: <a id="tb#{article.tb_no}" href="#{article.url}"><span class="trackbacktitle">#{title}</span></a><br />
  <strong>BlogName:</strong> #{article.blog_name}<br />
  <strong>Date:</strong> #{article.date.strftime('%Y/%m/%d %H:%M:%S')}<br />
  <strong>Excerpt:</strong> #{article.excerpt}<br />
  <strong>host:</strong> #{article.host}<br />
  <strong>ip:</strong> #{article.ip}<br />
#{article.delete_flag ? '</del>' : ''}
  </p>
ITEM_END

      }

      css = %Q!\n  <link rel="stylesheet" type="text/css" href="#{CSS}" />! unless CSS.to_s.empty?
  
      
      print <<HTML_END
Content-Type: text/html; charset=Shift_JIS

<?xml version="1.0" encoding="Shift_JIS"?>
<!DOCTYPE html
   PUBLIC "-//W3C//DTD XHTML 1.1//EN"
   "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS" />
  <meta http-equiv="Content-Style-Type" content="text/css" />#{css}
  <title>#{TITLE} (#{@cgi.path_info[1..-1]}) : Ǘ҃[h</title>
</head>

<body>
<h1>#{TITLE} (#{@cgi.path_info[1..-1]}) : Ǘ҃[h</h1>

<hr>

<div class="trackback">
<form name="tbform" action="http://#{@cgi.server_name + @cgi.script_name + @cgi.path_info}"
method="POST" enctype="application/x-www-form-urlencoded">
<input name="__mode" type="hidden" value="admin">
<input name="password" type="hidden" value="#{@cgi['password'][0]}">
#{items}
`FbNL̍폜E 
<input type="submit" value="s" class="submit">
</form>
</div>

</body>
</html>
HTML_END

    end

    def password_form
      values = ''
      @cgi.params.each{ |key, vals|
        vals.each{ |val|
          values << %Q!<input type="hidden" name="#{key}" value="#{val}">\n!
        }
      }
      css = %Q!\n  <link rel="stylesheet" type="text/css" href="#{CSS}" />! unless CSS.to_s.empty?

      print <<HTML_END
Content-Type: text/html; charset=Shift_JIS

<?xml version="1.0" encoding="Shift_JIS"?>
<!DOCTYPE html
   PUBLIC "-//W3C//DTD XHTML 1.1//EN"
   "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS" />
  <meta http-equiv="Content-Style-Type" content="text/css" />#{css}
  <title>#{TITLE} (#{@cgi.path_info[1..-1]}) : pX[h̓</title>
</head>

<body>
<h1>#{TITLE} (#{@cgi.path_info[1..-1]}) : pX[h̓</h1>

<p>pX[h͂Ă</p>

<div class="trackback">
<form name="tbform" action="http://#{@cgi.server_name + @cgi.script_name + @cgi.path_info}"
method="POST" enctype="application/x-www-form-urlencoded">
#{values}
Password: 
<input name="password" type="password">
<input type="submit" value="s" class="submit">
</form>
</div>

</body>
</html>
HTML_END

    end
    
    def view_list
      list = Articles::new(@cgi.path_info[1..-1])
      items = ''
      list.each{ |article|
        unless article.delete_flag then
          items << "<item>\n<title>#{article.title.toeuc}</title>\n"
          items << "<link>#{article.url}</link>\n"
          items << "<description>#{article.excerpt.toeuc}</description>\n</item>\n"
        end
      }
      
      print <<RSS_END
Content-Type: text/xml; charset=EUC-JP

<?xml version="1.0" encoding="EUC-JP"?>
<response>
<error>0</error>
<rss version="0.91">
<channel>
<title></title>
<link>#{LINK_BASE + date2monthlyfilelink(@cgi.path_info[1..-1], true)}</link>
<description></description>
<language>ja-JP</language>
#{items}</channel>
</rss>
</response>
RSS_END

    end

    def success_response

      print <<RSS_END
Content-Type: text/xml; charset=iso-8859-1

<?xml version="1.0" encoding="iso-8859-1"?>
<response>
<error>0</error>
</response>
RSS_END

    end

    def error_response(message)

    print <<RSS_END
Content-Type: text/xml; charset=iso-8859-1

<?xml version="1.0" encoding="iso-8859-1"?>
<response>
<error>1</error>
<message>Error Message: #{message}</message>
</response>
RSS_END

    end

    def date2monthlyfilename(date)
      date = first_date_of_month(date) if date.size == 6
      unless date.empty? then
        yyyy = date[0..3]
        mm   = date[4..5]
        dd   = date[6..7]

        @monthlyFilename.gsub('%Y', yyyy).gsub('%0m', mm).gsub(/^(.+)(\.[^\/]+)$/,"\\1#{@monthPartNames[dd.to_i]}\\2")
      else
        ''
      end
    end

    def date2fileanchor(date)
      (OUTPUT_XHTML ? 'd' : '' ) + date[6..7]
    end

    def date2monthlyfilelink(date, anchor = nil)
      filename = date2monthlyfilename(date)
      if anchor then
        filename << '#'
        filename << date2fileanchor(date)
      end
    end

    def update_diaryfile_lastmodified

      begin
        File::utime(@now, @now, DIARY_FILENAME) if UPDATE_DIARYFILE_LASTMODIFIED
      rescue Errno::EPERM
        open(DIARY_FILENAME, 'a'){|f| f.write "\n"}
      end
    end

    def sendmail(article)
      return if MAILTO.to_s.empty?
      from = 'dummy@exsample.com'
      to = [ MAILTO ]
      mail = <<MAIL_END
From: #{from}
To: #{MAILTO}
Subject: Trackbacked #{@cgi.path_info[1..-1]}
Date: #{@now.strftime("%a, #{@now.day} %b %Y %H:%M:%S +0900")}
Content-Type: text/plain; charset="iso-2022-jp"
Content-Transfer-Encoding: 7bit
X-Mailer: nTrackBack

title:     #{article.title.tojis}
url:       #{article.url}
blog_name: #{article.blog_name.tojis}
ip:        #{article.ip}
host:      #{article.host}
excerpt:   #{article.excerpt.tojis}
MAIL_END

      if SENDMAIL.to_s.empty? then
        smtp = Net::SMTP::start('localhost')
        smtp.sendmail(mail, from, to)
        smtp.finish

      else
        open("|#{SENDMAIL} -t -i", "w"){ |smtp|
          smtp.print mail
        }
      end
    end
  end

  class Article

    attr_accessor :title
    attr_accessor :excerpt
    attr_accessor :url
    attr_accessor :blog_name
    attr_accessor :date
    attr_accessor :tb_date
    attr_accessor :tb_no
    attr_accessor :delete_flag
    attr_accessor :ip
    attr_accessor :host
    attr_accessor :update

    def initialize
      @title = ''
      @excerpt = ''
      @url = ''
      @blog_name = ''
      @date = Time::now
      @delete_flag = nil
      @ip = ''
      @host = ''
      @update = nil
    end

    def Article::parse(str)
      article = Article::new

      header, excerpt = str.split(/\n\n/, 2)
      header.each{ |line|
        if line =~ /^title: (.*)$/ then
          article.title = $1
        elsif line =~ /^url: (.*)$/ then
          article.url = $1
        elsif line =~ /^blog_name: (.*)$/ then
          article.blog_name = $1
        elsif line =~ %r!^date: (\d\d\d\d)/(\d\d)/(\d\d) (\d\d):(\d\d):(\d\d)$! then
          begin
            article.date = Time::local($1, $2, $3, $4, $5, $6)
          rescue
            article.date = Time::at(0)
          end
        elsif line =~ /^no: (.*)$/ then
          article.tb_no = $1.to_i
        elsif line =~ /^blog_name: (.*)$/ then
          article.blog_name = $1
        elsif line =~ /^delete_flag: (.*)$/ then
          article.delete_flag = ($1 == "true")
        elsif line =~ /^ip: (.*)$/ then
          article.ip = $1
        elsif line =~ /^host: (.*)$/ then
          article.host = $1
        end
      }
      article.excerpt = excerpt.strip

      if %r"^http://" !~ article.url then
        return false
      else
        return article
      end
    end
      
    def to_s
        str = <<ARTICLE_END
title: #{@title}
url: #{@url}
blog_name: #{@blog_name}
date: #{@date.strftime('%Y/%m/%d %H:%M:%S')}
delete_flag: #{@delete_flag.to_s}
no: #{@tb_no}
ip: #{@ip}
host: #{@host}

#{@excerpt}
ARTICLE_END

      return str
    end

  end

  class Articles < Array

    def initialize(date)
      @date = date
      load
    end

    def add(article)
      article.update = true
      article.tb_no = self.size + 1
      self << article
    end
    
    def load
      begin
        Dir::glob(LOG_DIRECTORY + '/' + @date + '/[0-9][0-9][0-9]' + '.txt').each{ |filename|
          open(filename){ |f|
            article = Article::parse(f.read)
            self << article if article
          }
        }
      rescue
      end
    end

    def save
      File::makedirs(LOG_DIRECTORY + '/' + @date)
      File::chmod(0777, LOG_DIRECTORY + '/' + @date)
      self.each{ |article|
        if article.update then
          open(LOG_DIRECTORY + '/' + @date + '/' + sprintf('%03d', article.tb_no) + '.txt', 'w'){ |f|
            f.write article.to_s

          }
          File::chmod(0666, LOG_DIRECTORY + '/' + @date + '/' + sprintf('%03d', article.tb_no) + '.txt')
        end
      }
    end
  end

end
